#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cerr.tie(nullptr);
    int n;
    cin >> n;
    unsigned long long a[n];
    int br[40];
    for (int i = 0; i < 40; i++)
        br[i] = 0;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        int b = a[i];
        for (int j = 0; b != 0; j++) {
            br[j] += b % 2;
            b >>= 1;
        }
    }
    int q;
    cin >> q;
    bool t;
    int k;
    unsigned long long x;
    while (q--) {
        cin >> t >> k;
        k--;
        if (t) {
            cin >> x;
            for (int j = 0; a[k] != 0; j++) {
                br[j] -= a[k] % 2;
                a[k] >>= 1;
            }
            a[k] = x;
            for (int j = 0; x != 0; j++) {
                br[j] += x % 2;
                x >>= 1;
            }
        }
        else {
            unsigned long long b = 0;
            for (int i = 0; i < 40; i++) {
                if (br[i] > k)
                b += 1 << i;
            }
            cout << b << '\n';
        }
    }
    return 0;
}